#include "StdAfx.h"
#include "Morph.h"

#pragma comment(lib, "Ole32.lib")

const CLSID CLSID_MSIME_JAPANESE = {0xaf9ee286, 0x8cd3, 0x445e, {0x88, 0x42, 0x43, 0x3e, 0x5c, 0x46, 0x07, 0x75}};
const IID IID_IFELanguage2 = {0x21164102, 0xc24a, 0x11d1, {0x85, 0x1a, 0x0, 0xc0, 0x4f, 0xcc, 0x6b, 0x14}};
const IID IID_IFELanguage  = {0x19f7152, 0xe6db, 0x11d0, {0x83, 0xc3, 0x0, 0xc0, 0x4f, 0xdd, 0xb8, 0x2e}};

WordDescription::WordDescription(System::String^ disp, System::String^ read, int pos)
:disp(disp)
,read(read)
,pos(static_cast<WordClass>(pos))
{
}

System::String^ WordDescription::Pos::get()
{
	if( posDictionary == nullptr)
	{
		posDictionary = gcnew System::Collections::Generic::Dictionary<WordClass, System::String^>();
		posDictionary->Add(WordClass::WORDCLASS_UNDEFINED, L"s");
		posDictionary->Add(WordClass::WORDCLASS_MEISHI_FUTSU,     L"");
		posDictionary->Add(WordClass::WORDCLASS_MEISHI_SAHEN,     L"ϖ");
		posDictionary->Add(WordClass::WORDCLASS_MEISHI_ZAHEN,     L"ϖ");
		posDictionary->Add(WordClass::WORDCLASS_MEISHI_KEIYOUDOUSHI,     L"`");
		posDictionary->Add(WordClass::WORDCLASS_HUKUSIMEISHI,     L"I");
		posDictionary->Add(WordClass::WORDCLASS_MEISA_KEIDOU,     L"ό`");
		posDictionary->Add(WordClass::WORDCLASS_JINMEI,     L"l");
		posDictionary->Add(WordClass::WORDCLASS_JINMEI_SEI,     L"");
		posDictionary->Add(WordClass::WORDCLASS_JINMEI_MEI,     L"");
		posDictionary->Add(WordClass::WORDCLASS_CHIMEI,     L"n");
		posDictionary->Add(WordClass::WORDCLASS_CHIMEI_KUNI,     L"");
		posDictionary->Add(WordClass::WORDCLASS_CHIMEI_KEN,     L"");
		posDictionary->Add(WordClass::WORDCLASS_CHIMEI_GUN,     L"S");
		posDictionary->Add(WordClass::WORDCLASS_CHIMEI_KU,     L"");
		posDictionary->Add(WordClass::WORDCLASS_CHIMEI_SHI,     L"s");
		posDictionary->Add(WordClass::WORDCLASS_CHIMEI_MACHI,     L"");
		posDictionary->Add(WordClass::WORDCLASS_CHIMEI_MURA,     L"");
		posDictionary->Add(WordClass::WORDCLASS_CHIMEI_EKI,     L"w");
		posDictionary->Add(WordClass::WORDCLASS_SONOTA,     L"ŗL");
		posDictionary->Add(WordClass::WORDCLASS_SHAMEI,     L"Ж");
		posDictionary->Add(WordClass::WORDCLASS_SOSHIKI,     L"gD");
		posDictionary->Add(WordClass::WORDCLASS_KENCHIKU,     L"z");
		posDictionary->Add(WordClass::WORDCLASS_BUPPIN,     L"i");
		posDictionary->Add(WordClass::WORDCLASS_DAIMEISHI,     L"㖼");
		posDictionary->Add(WordClass::WORDCLASS_DAIMEISHI_NINSHOU,     L"l̑㖼");
		posDictionary->Add(WordClass::WORDCLASS_DAIMEISHI_SHIJI,     L"w㖼");
		posDictionary->Add(WordClass::WORDCLASS_KAZU,     L"");
		posDictionary->Add(WordClass::WORDCLASS_KAZU_SURYOU,     L"");
		posDictionary->Add(WordClass::WORDCLASS_KAZU_SUSHI,     L"");
		posDictionary->Add(WordClass::WORDCLASS_5DAN_AWA,     L"s");
		posDictionary->Add(WordClass::WORDCLASS_5DAN_KA,     L"s");
		posDictionary->Add(WordClass::WORDCLASS_5DAN_GA,     L"s");
		posDictionary->Add(WordClass::WORDCLASS_5DAN_SA,     L"s");
		posDictionary->Add(WordClass::WORDCLASS_5DAN_TA,     L"s");
		posDictionary->Add(WordClass::WORDCLASS_5DAN_NA,     L"ȍs");
		posDictionary->Add(WordClass::WORDCLASS_5DAN_BA,     L"΍s");
		posDictionary->Add(WordClass::WORDCLASS_5DAN_MA,     L"܍s");
		posDictionary->Add(WordClass::WORDCLASS_5DAN_RA,     L"s");
		posDictionary->Add(WordClass::WORDCLASS_5DAN_AWAUON,     L"s");
		posDictionary->Add(WordClass::WORDCLASS_5DAN_KASOKUON,     L"s");
		posDictionary->Add(WordClass::WORDCLASS_5DAN_RAHEN,     L"sϊi");
		posDictionary->Add(WordClass::WORDCLASS_4DAN_HA,     L"͍sli");
		posDictionary->Add(WordClass::WORDCLASS_1DAN,     L"i");
		posDictionary->Add(WordClass::WORDCLASS_TOKUSHU_KAHEN,     L"ϓ");
		posDictionary->Add(WordClass::WORDCLASS_TOKUSHU_SAHENSURU,     L"ϓ");
		posDictionary->Add(WordClass::WORDCLASS_TOKUSHU_SAHEN,     L"sϊi");
		posDictionary->Add(WordClass::WORDCLASS_TOKUSHU_ZAHEN,     L"sϊi");
		posDictionary->Add(WordClass::WORDCLASS_TOKUSHU_NAHEN,     L"ȍsϊi");
		posDictionary->Add(WordClass::WORDCLASS_KURU_KI,     L"");
		posDictionary->Add(WordClass::WORDCLASS_KURU_KITA,     L"");
		posDictionary->Add(WordClass::WORDCLASS_KURU_KITARA,     L"");
		posDictionary->Add(WordClass::WORDCLASS_KURU_KITARI,     L"");
		posDictionary->Add(WordClass::WORDCLASS_KURU_KITAROU,     L"낤");
		posDictionary->Add(WordClass::WORDCLASS_KURU_KITE,     L"");
		posDictionary->Add(WordClass::WORDCLASS_KURU_KUREBA,     L"");
		posDictionary->Add(WordClass::WORDCLASS_KURU_KO,     L"iȂj");
		posDictionary->Add(WordClass::WORDCLASS_KURU_KOI,     L"");
		posDictionary->Add(WordClass::WORDCLASS_KURU_KOYOU,     L"悤");
		posDictionary->Add(WordClass::WORDCLASS_SURU_SA,     L"");
		posDictionary->Add(WordClass::WORDCLASS_SURU_SI,     L"");
		posDictionary->Add(WordClass::WORDCLASS_SURU_SITA,     L"");
		posDictionary->Add(WordClass::WORDCLASS_SURU_SITARA,     L"");
		posDictionary->Add(WordClass::WORDCLASS_SURU_SIATRI,     L"");
		posDictionary->Add(WordClass::WORDCLASS_SURU_SITAROU,     L"낤");
		posDictionary->Add(WordClass::WORDCLASS_SURU_SITE,     L"");
		posDictionary->Add(WordClass::WORDCLASS_SURU_SIYOU,     L"悤");
		posDictionary->Add(WordClass::WORDCLASS_SURU_SUREBA,     L"");
		posDictionary->Add(WordClass::WORDCLASS_SURU_SE,     L"");
		posDictionary->Add(WordClass::WORDCLASS_SURU_SEYO,     L"^");
		posDictionary->Add(WordClass::WORDCLASS_KEIYOU,     L"`e");
		posDictionary->Add(WordClass::WORDCLASS_KEIYOU_GARU,     L"`e");
		posDictionary->Add(WordClass::WORDCLASS_KEIYOU_GE,     L"`e");
		posDictionary->Add(WordClass::WORDCLASS_KEIYOU_ME,     L"`e");
		posDictionary->Add(WordClass::WORDCLASS_KEIYOU_YUU,     L"`e");
		posDictionary->Add(WordClass::WORDCLASS_KEIYOU_U,     L"`e");
		posDictionary->Add(WordClass::WORDCLASS_KEIDOU,     L"`e");
		posDictionary->Add(WordClass::WORDCLASS_KEIDOU_NO,     L"`e");
		posDictionary->Add(WordClass::WORDCLASS_KEIDOU_TARU,     L"`e");
		posDictionary->Add(WordClass::WORDCLASS_KEIDOU_GARU,     L"`e");
		posDictionary->Add(WordClass::WORDCLASS_FUKUSHI,     L"");
		posDictionary->Add(WordClass::WORDCLASS_FUKUSHI_SAHEN,     L"ϕ");
		posDictionary->Add(WordClass::WORDCLASS_FUKUSHI_NI,     L"");
		posDictionary->Add(WordClass::WORDCLASS_FUKUSHI_NANO,     L"");
		posDictionary->Add(WordClass::WORDCLASS_FUKUSHI_DA,     L"");
		posDictionary->Add(WordClass::WORDCLASS_FUKUSHI_TO,     L"");
		posDictionary->Add(WordClass::WORDCLASS_FUKUSHI_TOSURU,     L"Ă");
		posDictionary->Add(WordClass::WORDCLASS_RENTAISHI,     L"A̎");
		posDictionary->Add(WordClass::WORDCLASS_RENTAISHI_SHIJI,     L"wA̎");
		posDictionary->Add(WordClass::WORDCLASS_SETSUZOKUSHI,     L"ڑ");
		posDictionary->Add(WordClass::WORDCLASS_KANDOUSHI,     L"");
		posDictionary->Add(WordClass::WORDCLASS_SETTOU,     L"ړ");
		posDictionary->Add(WordClass::WORDCLASS_SETTOU_KAKU,     L"Pړ");
		posDictionary->Add(WordClass::WORDCLASS_SETTOU_SAI,     L"Qړ");
		posDictionary->Add(WordClass::WORDCLASS_SETTOU_FUKU,     L"Rړ");
		posDictionary->Add(WordClass::WORDCLASS_SETTOU_MI,     L"Sړ");
		posDictionary->Add(WordClass::WORDCLASS_SETTOU_DAISHOU,     L"Tړ");
		posDictionary->Add(WordClass::WORDCLASS_SETTOU_KOUTEI,     L"Uړ");
		posDictionary->Add(WordClass::WORDCLASS_SETTOU_CHOUTAN,     L"Vړ");
		posDictionary->Add(WordClass::WORDCLASS_SETTOU_SHINKYU,     L"Wړ");
		posDictionary->Add(WordClass::WORDCLASS_SETTOU_JINMEI,     L"lړ");
		posDictionary->Add(WordClass::WORDCLASS_SETTOU_CHIMEI,     L"nړ");
		posDictionary->Add(WordClass::WORDCLASS_SETTOU_SONOTA,     L"ŗLړ");
		posDictionary->Add(WordClass::WORDCLASS_SETTOU_JOSUSHI,     L"Ou");
		posDictionary->Add(WordClass::WORDCLASS_SETTOU_TEINEI_O,     L"JPړ");
		posDictionary->Add(WordClass::WORDCLASS_SETTOU_TEINEI_GO,     L"JQړ");
		posDictionary->Add(WordClass::WORDCLASS_SETTOU_TEINEI_ON,     L"JRړ");
		posDictionary->Add(WordClass::WORDCLASS_SETSUBI,     L"ڔ");
		posDictionary->Add(WordClass::WORDCLASS_SETSUBI_TEKI,     L"Pڔ");
		posDictionary->Add(WordClass::WORDCLASS_SETSUBI_SEI,     L"Qڔ");
		posDictionary->Add(WordClass::WORDCLASS_SETSUBI_KA,     L"Rڔ");
		posDictionary->Add(WordClass::WORDCLASS_SETSUBI_CHU,     L"Sڔ");
		posDictionary->Add(WordClass::WORDCLASS_SETSUBI_FU,     L"Tڔ");
		posDictionary->Add(WordClass::WORDCLASS_SETSUBI_RYU,     L"Uڔ");
		posDictionary->Add(WordClass::WORDCLASS_SETSUBI_YOU,     L"Vڔ");
		posDictionary->Add(WordClass::WORDCLASS_SETSUBI_KATA,     L"Wڔ");
		posDictionary->Add(WordClass::WORDCLASS_SETSUBI_MEISHIRENDAKU,     L"A");
		posDictionary->Add(WordClass::WORDCLASS_SETSUBI_JINMEI,     L"lڔ");
		posDictionary->Add(WordClass::WORDCLASS_SETSUBI_CHIMEI,     L"nڔ");
		posDictionary->Add(WordClass::WORDCLASS_SETSUBI_KUNI,     L"ڔ");
		posDictionary->Add(WordClass::WORDCLASS_SETSUBI_KEN,     L"ڔ");
		posDictionary->Add(WordClass::WORDCLASS_SETSUBI_GUN,     L"Sڔ");
		posDictionary->Add(WordClass::WORDCLASS_SETSUBI_KU,     L"ڔ");
		posDictionary->Add(WordClass::WORDCLASS_SETSUBI_SHI,     L"sڔ");
		posDictionary->Add(WordClass::WORDCLASS_SETSUBI_MACHI,     L"Pڔ");
		posDictionary->Add(WordClass::WORDCLASS_SETSUBI_CHOU,     L"Qڔ");
		posDictionary->Add(WordClass::WORDCLASS_SETSUBI_MURA,     L"Pڔ");
		posDictionary->Add(WordClass::WORDCLASS_SETSUBI_SON,     L"Qڔ");
		posDictionary->Add(WordClass::WORDCLASS_SETSUBI_EKI,     L"wڔ");
		posDictionary->Add(WordClass::WORDCLASS_SETSUBI_SONOTA,     L"ŗLڔ");
		posDictionary->Add(WordClass::WORDCLASS_SETSUBI_SHAMEI,     L"Жڔ");
		posDictionary->Add(WordClass::WORDCLASS_SETSUBI_SOSHIKI,     L"gDڔ");
		posDictionary->Add(WordClass::WORDCLASS_SETSUBI_KENCHIKU,     L"zڔ");
		posDictionary->Add(WordClass::WORDCLASS_RENYOU_SETSUBI,     L"Apڔ");
		posDictionary->Add(WordClass::WORDCLASS_SETSUBI_JOSUSHI,     L"u");
		posDictionary->Add(WordClass::WORDCLASS_SETSUBI_JOSUSHIPLUS,     L"u{");
		posDictionary->Add(WordClass::WORDCLASS_SETSUBI_JIKAN,     L"ԏ");
		posDictionary->Add(WordClass::WORDCLASS_SETSUBI_JIKANPLUS,     L"ԏ{");
		posDictionary->Add(WordClass::WORDCLASS_SETSUBI_TEINEI,     L"Jڔ");
		posDictionary->Add(WordClass::WORDCLASS_SETSUBI_SAN,     L"JPڔ");
		posDictionary->Add(WordClass::WORDCLASS_SETSUBI_KUN,     L"JQڔ");
		posDictionary->Add(WordClass::WORDCLASS_SETSUBI_SAMA,     L"JRڔ");
		posDictionary->Add(WordClass::WORDCLASS_SETSUBI_DONO,     L"JSڔ");
		posDictionary->Add(WordClass::WORDCLASS_SETSUBI_FUKUSU,     L"ڔ");
		posDictionary->Add(WordClass::WORDCLASS_SETSUBI_TACHI,     L"Pڔ");
		posDictionary->Add(WordClass::WORDCLASS_SETSUBI_RA,     L"Qڔ");
		posDictionary->Add(WordClass::WORDCLASS_TANKANJI,     L"P");
		posDictionary->Add(WordClass::WORDCLASS_TANKANJI_KAO,     L"");
		posDictionary->Add(WordClass::WORDCLASS_KANYOUKU,     L"p");
		posDictionary->Add(WordClass::WORDCLASS_DOKURITSUGO,     L"Ɨ");
		posDictionary->Add(WordClass::WORDCLASS_FUTEIGO,     L"s");
		posDictionary->Add(WordClass::WORDCLASS_KIGOU,     L"L");
		posDictionary->Add(WordClass::WORDCLASS_EIJI,     L"p");
		posDictionary->Add(WordClass::WORDCLASS_KUTEN,     L"_");
		posDictionary->Add(WordClass::WORDCLASS_TOUTEN,     L"Ǔ_");
		posDictionary->Add(WordClass::WORDCLASS_KANJI,     L"͕s\");
		posDictionary->Add(WordClass::WORDCLASS_OPENBRACE,     L"J");
		posDictionary->Add(WordClass::WORDCLASS_CLOSEBRACE,     L"");
		posDictionary->Add(WordClass::WORDCLASS_YOKUSEI,     L"");
	}

	if( posDictionary->ContainsKey( this->pos) == false)
	{
		return L"s";
	}
	return posDictionary[this->pos];
}

Morph::Morph(void)
{
	m_piLanguage = NULL;
}

void Morph::Open()
{
	void* p = NULL;
//	HRESULT hr = ::CoCreateInstance( CLSID_MSIME_JAPANESE,NULL,CLSCTX_ALL, IID_IFELanguage,(void**)&m_piLanguage );
	HRESULT hr = ::CoCreateInstance( CLSID_MSIME_JAPANESE,NULL,CLSCTX_ALL, IID_IFELanguage, &p );
	m_piLanguage = (IFELanguage*)p;
	if( m_piLanguage != NULL)
	{
		m_piLanguage->Open();
	}
	else
	{
		throw gcnew System::Exception("IME Open failed");
	}
}

void Morph::Close()
{
	if( m_piLanguage != NULL)
	{
		m_piLanguage->Close();
		m_piLanguage->Release();
		m_piLanguage = NULL;
	}
}

array<WordDescription^>^ Morph::GetJMorph(System::String^ input)
{
	if( m_piLanguage == NULL)
	{
		return nullptr;
	}

	MORRSLT* pResult = NULL;
	System::IntPtr bstr = System::Runtime::InteropServices::Marshal::StringToBSTR( input);
	WCHAR* pwchar = static_cast<WCHAR*>(bstr.ToPointer());
	HRESULT hr = m_piLanguage->GetJMorphResult( FELANG_REQ_REV, 0, input->Length, pwchar, NULL, &pResult);
	System::Runtime::InteropServices::Marshal::FreeBSTR( bstr);

	if( pResult == NULL)
	{
		return nullptr;
	}

	System::String^ out = gcnew System::String( pResult->pwchOutput);
	System::String^ read = gcnew System::String( pResult->pwchRead);

	array<WordDescription^>^ result = gcnew array<WordDescription^>(pResult->cWDD);
	for( int i = 0; i < pResult->cWDD; i++)
	{
		WDD* pWDD = &( pResult->pWDD[ i]);
		System::String^ outItem = out->Substring( pWDD->wDispPos, pWDD->cchDisp);
		System::String^ readItem = read->Substring( pWDD->wReadPos, pWDD->cchRead);

		result[i] = gcnew WordDescription( outItem, readItem, pWDD->nPos);
	}

	return result;
}
