#pragma once
#include "MSIME.H"

enum class WordClass
{
	WORDCLASS_UNDEFINED          = 0,

	WORDCLASS_MEISHI_FUTSU       = 100,     //
	WORDCLASS_MEISHI_SAHEN       = 101,     //ϖ
	WORDCLASS_MEISHI_ZAHEN       = 102,     //ϖ
	WORDCLASS_MEISHI_KEIYOUDOUSHI	= 103,     //`
	WORDCLASS_HUKUSIMEISHI       = 104,     //I
	WORDCLASS_MEISA_KEIDOU       = 105,     //ό`
	WORDCLASS_JINMEI     = 106,     //l
	WORDCLASS_JINMEI_SEI     = 107,     //
	WORDCLASS_JINMEI_MEI     = 108,     //
	WORDCLASS_CHIMEI     = 109,     //n
	WORDCLASS_CHIMEI_KUNI        = 110,     //
	WORDCLASS_CHIMEI_KEN     = 111,     //
	WORDCLASS_CHIMEI_GUN     = 112,     //S
	WORDCLASS_CHIMEI_KU      = 113,     //
	WORDCLASS_CHIMEI_SHI     = 114,     //s
	WORDCLASS_CHIMEI_MACHI       = 115,     //
	WORDCLASS_CHIMEI_MURA        = 116,     //
	WORDCLASS_CHIMEI_EKI     = 117,     //w
	WORDCLASS_SONOTA     = 118,     //ŗL
	WORDCLASS_SHAMEI     = 119,     //Ж
	WORDCLASS_SOSHIKI        = 120,     //gD
	WORDCLASS_KENCHIKU       = 121,     //z
	WORDCLASS_BUPPIN     = 122,     //i
	WORDCLASS_DAIMEISHI      = 123,     //㖼
	WORDCLASS_DAIMEISHI_NINSHOU      = 124,     //l̑㖼
	WORDCLASS_DAIMEISHI_SHIJI        = 125,     //w㖼
	WORDCLASS_KAZU       = 126,     //
	WORDCLASS_KAZU_SURYOU        = 127,     //
	WORDCLASS_KAZU_SUSHI     = 128,     //
	WORDCLASS_5DAN_AWA       = 200,     //s
	WORDCLASS_5DAN_KA        = 201,     //s
	WORDCLASS_5DAN_GA        = 202,     //s
	WORDCLASS_5DAN_SA        = 203,     //s
	WORDCLASS_5DAN_TA        = 204,     //s
	WORDCLASS_5DAN_NA        = 205,     //ȍs
	WORDCLASS_5DAN_BA        = 206,     //΍s
	WORDCLASS_5DAN_MA        = 207,     //܍s
	WORDCLASS_5DAN_RA        = 208,     //s
	WORDCLASS_5DAN_AWAUON        = 209,     //s
	WORDCLASS_5DAN_KASOKUON      = 210,     //s
	WORDCLASS_5DAN_RAHEN     = 211,     //sϊi
	WORDCLASS_4DAN_HA        = 212,     //͍sli
	WORDCLASS_1DAN       = 213,     //i
	WORDCLASS_TOKUSHU_KAHEN      = 214,     //ϓ
	WORDCLASS_TOKUSHU_SAHENSURU      = 215,     //ϓ
	WORDCLASS_TOKUSHU_SAHEN      = 216,     //sϊi
	WORDCLASS_TOKUSHU_ZAHEN      = 217,     //sϊi
	WORDCLASS_TOKUSHU_NAHEN      = 218,     //ȍsϊi
	WORDCLASS_KURU_KI        = 219,     //
	WORDCLASS_KURU_KITA      = 220,     //
	WORDCLASS_KURU_KITARA        = 221,     //
	WORDCLASS_KURU_KITARI        = 222,     //
	WORDCLASS_KURU_KITAROU       = 223,     //낤
	WORDCLASS_KURU_KITE      = 224,     //
	WORDCLASS_KURU_KUREBA        = 225,     //
	WORDCLASS_KURU_KO        = 226,     //iȂj
	WORDCLASS_KURU_KOI       = 227,     //
	WORDCLASS_KURU_KOYOU     = 228,     //悤
	WORDCLASS_SURU_SA        = 229,     //
	WORDCLASS_SURU_SI        = 230,     //
	WORDCLASS_SURU_SITA      = 231,     //
	WORDCLASS_SURU_SITARA        = 232,     //
	WORDCLASS_SURU_SIATRI        = 233,     //
	WORDCLASS_SURU_SITAROU       = 234,     //낤
	WORDCLASS_SURU_SITE      = 235,     //
	WORDCLASS_SURU_SIYOU     = 236,     //悤
	WORDCLASS_SURU_SUREBA        = 237,     //
	WORDCLASS_SURU_SE        = 238,     //
	WORDCLASS_SURU_SEYO      = 239,     //^
	WORDCLASS_KEIYOU     = 300,     //`e
	WORDCLASS_KEIYOU_GARU        = 301,     //`e
	WORDCLASS_KEIYOU_GE      = 302,     //`e
	WORDCLASS_KEIYOU_ME      = 303,     //`e
	WORDCLASS_KEIYOU_YUU     = 304,     //`e
	WORDCLASS_KEIYOU_U       = 305,     //`e
	WORDCLASS_KEIDOU     = 400,     //`e
	WORDCLASS_KEIDOU_NO      = 401,     //`e
	WORDCLASS_KEIDOU_TARU        = 402,     //`e
	WORDCLASS_KEIDOU_GARU        = 403,     //`e
	WORDCLASS_FUKUSHI        = 500,     //
	WORDCLASS_FUKUSHI_SAHEN      = 501,     //ϕ
	WORDCLASS_FUKUSHI_NI     = 502,     //
	WORDCLASS_FUKUSHI_NANO       = 503,     //
	WORDCLASS_FUKUSHI_DA     = 504,     //
	WORDCLASS_FUKUSHI_TO     = 505,     //
	WORDCLASS_FUKUSHI_TOSURU     = 506,     //Ă
	WORDCLASS_RENTAISHI      = 600,     //A̎
	WORDCLASS_RENTAISHI_SHIJI        = 601,     //wA̎
	WORDCLASS_SETSUZOKUSHI       = 650,     //ڑ
	WORDCLASS_KANDOUSHI      = 670,     //
	WORDCLASS_SETTOU     = 700,     //ړ
	WORDCLASS_SETTOU_KAKU        = 701,     //Pړ
	WORDCLASS_SETTOU_SAI     = 702,     //Qړ
	WORDCLASS_SETTOU_FUKU        = 703,     //Rړ
	WORDCLASS_SETTOU_MI      = 704,     //Sړ
	WORDCLASS_SETTOU_DAISHOU     = 705,     //Tړ
	WORDCLASS_SETTOU_KOUTEI      = 706,     //Uړ
	WORDCLASS_SETTOU_CHOUTAN     = 707,     //Vړ
	WORDCLASS_SETTOU_SHINKYU     = 708,     //Wړ
	WORDCLASS_SETTOU_JINMEI      = 709,     //lړ
	WORDCLASS_SETTOU_CHIMEI      = 710,     //nړ
	WORDCLASS_SETTOU_SONOTA      = 711,     //ŗLړ
	WORDCLASS_SETTOU_JOSUSHI     = 712,     //Ou
	WORDCLASS_SETTOU_TEINEI_O        = 713,     //JPړ
	WORDCLASS_SETTOU_TEINEI_GO       = 714,     //JQړ
	WORDCLASS_SETTOU_TEINEI_ON       = 715,     //JRړ
	WORDCLASS_SETSUBI        = 800,     //ڔ
	WORDCLASS_SETSUBI_TEKI       = 801,     //Pڔ
	WORDCLASS_SETSUBI_SEI        = 802,     //Qڔ
	WORDCLASS_SETSUBI_KA     = 803,     //Rڔ
	WORDCLASS_SETSUBI_CHU        = 804,     //Sڔ
	WORDCLASS_SETSUBI_FU     = 805,     //Tڔ
	WORDCLASS_SETSUBI_RYU        = 806,     //Uڔ
	WORDCLASS_SETSUBI_YOU        = 807,     //Vڔ
	WORDCLASS_SETSUBI_KATA       = 808,     //Wڔ
	WORDCLASS_SETSUBI_MEISHIRENDAKU      = 809,     //A
	WORDCLASS_SETSUBI_JINMEI     = 810,     //lڔ
	WORDCLASS_SETSUBI_CHIMEI     = 811,     //nڔ
	WORDCLASS_SETSUBI_KUNI       = 812,     //ڔ
	WORDCLASS_SETSUBI_KEN        = 813,     //ڔ
	WORDCLASS_SETSUBI_GUN        = 814,     //Sڔ
	WORDCLASS_SETSUBI_KU     = 815,     //ڔ
	WORDCLASS_SETSUBI_SHI        = 816,     //sڔ
	WORDCLASS_SETSUBI_MACHI      = 817,     //Pڔ
	WORDCLASS_SETSUBI_CHOU       = 818,     //Qڔ
	WORDCLASS_SETSUBI_MURA       = 819,     //Pڔ
	WORDCLASS_SETSUBI_SON        = 820,     //Qڔ
	WORDCLASS_SETSUBI_EKI        = 821,     //wڔ
	WORDCLASS_SETSUBI_SONOTA     = 822,     //ŗLڔ
	WORDCLASS_SETSUBI_SHAMEI     = 823,     //Жڔ
	WORDCLASS_SETSUBI_SOSHIKI        = 824,     //gDڔ
	WORDCLASS_SETSUBI_KENCHIKU       = 825,     //zڔ
	WORDCLASS_RENYOU_SETSUBI     = 826,     //Apڔ
	WORDCLASS_SETSUBI_JOSUSHI        = 827,     //u
	WORDCLASS_SETSUBI_JOSUSHIPLUS        = 828,     //u{
	WORDCLASS_SETSUBI_JIKAN      = 829,     //ԏ
	WORDCLASS_SETSUBI_JIKANPLUS      = 830,     //ԏ{
	WORDCLASS_SETSUBI_TEINEI     = 831,     //Jڔ
	WORDCLASS_SETSUBI_SAN        = 832,     //JPڔ
	WORDCLASS_SETSUBI_KUN        = 833,     //JQڔ
	WORDCLASS_SETSUBI_SAMA       = 834,     //JRڔ
	WORDCLASS_SETSUBI_DONO       = 835,     //JSڔ
	WORDCLASS_SETSUBI_FUKUSU     = 836,     //ڔ
	WORDCLASS_SETSUBI_TACHI      = 837,     //Pڔ
	WORDCLASS_SETSUBI_RA     = 838,     //Qڔ
	WORDCLASS_TANKANJI       = 900,     //P
	WORDCLASS_TANKANJI_KAO       = 901,     //
	WORDCLASS_KANYOUKU       = 902,     //p
	WORDCLASS_DOKURITSUGO        = 903,     //Ɨ
	WORDCLASS_FUTEIGO        = 904,     //s
	WORDCLASS_KIGOU      = 905,     //L
	WORDCLASS_EIJI       = 906,     //p
	WORDCLASS_KUTEN      = 907,     //_
	WORDCLASS_TOUTEN     = 908,     //Ǔ_
	WORDCLASS_KANJI      = 909,     //͕s\
	WORDCLASS_OPENBRACE      = 910,     //J
	WORDCLASS_CLOSEBRACE     = 911,     //
	WORDCLASS_YOKUSEI        = 912,     //
};

ref struct WordDescription
{
private:
	System::Collections::Generic::Dictionary<WordClass, System::String^>^ posDictionary;

public:
	WordDescription(System::String^ disp, System::String^ read, int pos);
	property System::String^ Pos
	{
		System::String^ get();
	}
	System::String^ disp;
	System::String^ read;
	WordClass pos;

	static bool operator==(WordDescription^ left, WordDescription^ right)
	{
		if( left->disp == right->disp
			&& left->pos == right->pos)
		{
			return true;
		}

		return false;
	}

	static bool operator!=(WordDescription^ left, WordDescription^ right)
	{
		return !( left = right);
	}

	virtual bool Equals(System::Object^ obj) override
	{
		WordDescription^ val = dynamic_cast<WordDescription^>(obj);
		return this->Equals(val);
	}

	bool Equals(WordDescription^ val)
	{
		return this == val;
	}

	virtual int GetHashCode() override
	{
		return disp->GetHashCode() ^ read->GetHashCode() ^ pos.GetHashCode();
	}

};

ref class Morph
{
private:
	IFELanguage* m_piLanguage;
public:
	Morph(void);
	void Open();
	void Close();
	array<WordDescription^>^ GetJMorph(System::String^ input);
};
