#include "StdAfx.h"
#include <TCHAR.H>
#include <mbstring.h>
#include "WordCounter.h"

#include "ProgressDialog.h"

WordCounter::WordCounter(void)
{
	countDictionary = gcnew System::Collections::Generic::Dictionary<WordDescription^, int>();
	morph = gcnew Morph();
	morph->Open();
}

WordCounter::~WordCounter()
{
	delete countDictionary;
	morph->Close();
	delete morph;
}

void WordCounter::Reset()
{
	countDictionary->Clear();
}

void WordCounter::Count(System::IO::StreamReader^ streamReader, long long length)
{
	MorphTest::ProgressDialog^ progressDialog = gcnew MorphTest::ProgressDialog();
	progressDialog->Title = L"͒";
	progressDialog->Minimum = 0;
	progressDialog->Maximum = length;
	progressDialog->Value = 0;
	progressDialog->Show();

	while(streamReader->EndOfStream == false)
	{
		System::String^ line = streamReader->ReadLine();
		Count( line);

		if( progressDialog->Canceled == true)
		{
			return;
		}
		progressDialog->Value += streamReader->CurrentEncoding->GetByteCount(line);
	}
	progressDialog->Close();
}

void WordCounter::Count(System::String^ line)
{
	if( line == System::String::Empty)
	{
		return;
	}

	array<WordDescription^>^ result = morph->GetJMorph(line);

	if( result == nullptr)
	{
		return;
	}

	for each( WordDescription^ wc in result)
	{
		int count = 0;
		if( countDictionary->ContainsKey(wc) == true)
		{
			count = countDictionary[wc];
			countDictionary->Remove(wc);
		}

		countDictionary->Add(wc, count+1);
	}
}

int WordCounterCompare(System::Collections::Generic::KeyValuePair < WordDescription^, int > kvp1,
						 System::Collections::Generic::KeyValuePair < WordDescription^, int > kvp2)
{
	return kvp2.Value - kvp1.Value;
}

System::Collections::Generic::List< System::Collections::Generic::KeyValuePair < WordDescription^, int > >^
WordCounter::Result::get()
{
	System::Collections::Generic::List< System::Collections::Generic::KeyValuePair< WordDescription^, int > >^ result
		= gcnew System::Collections::Generic::List< System::Collections::Generic::KeyValuePair< WordDescription^, int > >(countDictionary);
    
	result->Sort(gcnew System::Comparison< System::Collections::Generic::KeyValuePair< WordDescription^, int > >(WordCounterCompare));

	return result;
}

